{ (c) 1997 Peter 'NoWonder' Schneider-Kamp & Daniel Vollmer
  redistribution only on a non-profit basis, no fees to be charged
  for modifications and use please give credits to the authors}
{$R-}
{$S-}
{$Q-}
unit VBE;

{{$define _debug_}
{if not defined debug information are ommited}

{$optfrm-}
{$optreg-}
{just for the sake of matrox gfx cards ... they
just don't wanna run with optimizations (same
for watcom C/C++ based VBE-units}


interface

  type
    tRealPtr   = record
      ofs,
      seg        : word;
    end;
    tVbeInfo   = record
      id         : array [0..3] of char;
      version    : word;
      infostr    : tRealPtr;
      infodword  : dword;
      vidmodes   : tRealPtr;
      vidmem     : word;
    end;
    tModeInfo  = record
      attribute  : word;
      attr_wina,
      attr_winb  : byte;
      granul     : word;
      winsize    : word;
      seg_wina,
      seg_winb   : word;
      winfunc    : tRealPtr;
      linesize   : word;
      xres,
      yres       : word;
      charxres,
      charyres   : byte;
      memplanes  : byte;
      bpp        : byte;
      numbanks   : byte;
      memstruc   : byte;
      banksize   : byte;
      numpages   : byte;
      fill       : array [0..9] of byte;
      flatadr    : dword;
      hiddenscr  : dword;
      hiddensiz  : dword;
    end;

  var
    VbeInfo:tVbeInfo;
    ModeInfo:tModeInfo;
    pScreen:dword;
    vesainstalled,
    vcpiinstalled,
    dpmiinstalled:boolean;
    VirtualPage : Pointer;

  function  initvesa:boolean;
  function  searchmode(xres,yres,bpp:word):word;
  function  setmode(mode:word):boolean;
  procedure deinitvesa;
  Procedure SetRGB(c, r, g, b : Byte);
  Procedure SetPalette(Var P);


implementation

  const
    initstr    : string[15] = '-->> INIT <<--';
    modname    = 'TMTVBE';
    modversion = 'v0.92';
    crlf       = #13#10;
    bool       : array [0..1] of string[3] = ('n/a','OK');

  type
    tdpmiregs  = record
      edi,
      esi,
      ebp,
      reserved,
      ebx,
      edx,
      ecx,
      eax      : dword;
      flags    : word;
      es,
      ds,
      fs,
      gs,
      ip,
      cs,
      sp,
      ss       : word;
    end;

    var
      pBase,
      PageSize : dword;
      lastmode : byte;
      wininit  : boolean;



Procedure SetRGB(c, r, g, b : Byte);

Begin
  Port[$3c8] := c;
  Port[$3c9] := r;
  Port[$3c9] := g;
  Port[$3c9] := b;
End;

Procedure SetPalette(Var P);

Var
  i : DWord;
  pOfs : DWord;

Begin
  POfs := Ofs(P);
  For i := 0 to 255 do
    SetRGB(i, Mem[POfs+i*3], Mem[POfs+i*3+1], Mem[POfs+i*3+2]);
End;


{$ifdef _debug_}
  procedure readkey;code;
  asm
    xor    ax,ax
    int    16h
    ret    0
  end;

  function  bhex(a:byte):string;
    const
      HexChars:array [$0..$f] of char = '0123456789ABCDEF';
    var
      i:byte;
  begin
    bhex[0]:=#2;
    for i:=1 to 2 do bhex[i]:=hexchars[(a shr (8-i shl 2)) and $f];
  end;

  function  whex(a:word):string;
  begin
    whex:=bhex(byte(a shr 8))+bhex(byte(a));
  end;

  function  dhex(a:dword):string;
  begin
    dhex:=whex(word(a shr 16))+' '+whex(word(a));
  end;

  procedure dumpdpmiregs(dpmiregs:tdpmiregs);
  begin
    write  ('EAX = ',dhex(dpmiregs.eax),'   EBX = ',dhex(dpmiregs.ebx),'      ');
    writeln('ECX = ',dhex(dpmiregs.ecx),'   EDX = ',dhex(dpmiregs.edx));
    write  ('ESI = ',dhex(dpmiregs.esi),'   EDI = ',dhex(dpmiregs.edi),'      ');
    writeln('EBP = ',dhex(dpmiregs.ebp),' FLAGS = ',whex(dpmiregs.flags));
    write  (' CS =      ',whex(dpmiregs.cs),'    IP =      ',whex(dpmiregs.ip),'      ');
    writeln(' DS =      ',whex(dpmiregs.ds),'    ES =      ',whex(dpmiregs.es));
    write  (' FS =      ',whex(dpmiregs.fs),'    GS =      ',whex(dpmiregs.gs),'      ');
    writeln(' SS =      ',whex(dpmiregs.ss),'    SP =      ',whex(dpmiregs.sp));
    readkey;
  end;
{$endif}

{$ifdef _debug_}
  procedure callint(intnr:byte;var dpmiregs:tdpmiregs);
  begin
    dpmiregs.sp:=0;
    dpmiregs.ss:=0;
    writeln('  ## callint to             : ',bhex(intnr));
    writeln('  ## registers before call  : ');
    dumpdpmiregs(dpmiregs);
    asm
    mov    eax,$00000300
    xor    ebx,ebx
    mov    bl,intnr
    xor    ecx,ecx
    mov    edi,dpmiregs
    int    31h
    end;
    writeln('  ## registers after call   : ');
    dumpdpmiregs(dpmiregs);
  end;
{$else}
  procedure callint(intnr:byte;var dpmiregs:tdpmiregs);code;
  asm
    mov    eax,$00000300
    xor    ebx,ebx
    mov    bl,byte ptr [intnr]
    xor    ecx,ecx
    mov    edi,[dpmiregs]
    mov    dword ptr [edi+44],$00000000
    int    31h
    ret    8
  end;
{$endif}

  function  checkvcpi:boolean;
    var
      b:byte;
  begin
    b:=1;
    if memd[$67*4]<>0 then asm
      push   ebp
      push   ds es
      mov    eax,$de00
      int    $67
      mov    b,ah
      pop    es ds
      pop    ebp
    end;
    checkvcpi:=b=0;
  end;

  function  checkdpmi:boolean;
    var
      w:word;
  begin
    asm
      push   ebp
      push   ds es
      mov    ax,$1686
      int    $2f
      mov    w,ax
      pop    es ds
      pop    ebp

      push   ebp
      push   ds es
      mov    ax,$1687
      int    $2f
      and    w,ax
      pop    es ds
      pop    ebp
    end;
    checkdpmi:=w=0;
  end;

  function  initvesa:boolean;
    var
      dpmiregs : tdpmiregs;
  begin
    asm
      push   ebp
      push   ds es
      mov    ah,$0F
      int    10h
      mov    lastmode,al
      pop    es ds
      pop    ebp
    end;
    VbeInfo.id:='VBE2';
    move(VbeInfo,pointer(buf_32)^,sizeof(VbeInfo));
    fillchar(dpmiregs,sizeof(dpmiregs),0);
    dpmiregs.eax:=$00004F00;
    dpmiregs.es :=buf_16;
    dpmiregs.edi:=$00000000;
    callint($10,dpmiregs);
    move(pointer(buf_32)^,VbeInfo,sizeof(VbeInfo));
    initvesa:=word(dpmiregs.eax and $0000FFFF)=$004F;
  end;

  function  searchmode(xres,yres,bpp:word):word;
    var
      listadr:dword;
      modefound:boolean;
      dpmiregs:tdpmiregs;
  begin
    if (xres=320) and (yres=200) and (bpp=8) then begin
      searchmode:=$0013;
      pScreen:=$A0000;
      pBase:=$A0000;
      PageSize:=0;
      ModeInfo.xres:=320;
      ModeInfo.yres:=200;
      ModeInfo.bpp:=8;
      ModeInfo.linesize:=320;
    end else begin
      listadr:=VbeInfo.vidmodes.seg shl 4+VbeInfo.vidmodes.ofs;
      modefound:=false;
      while (memw[listadr]<>$FFFF) and not modefound do begin
        fillchar(dpmiregs,sizeof(dpmiregs),0);
        dpmiregs.eax:=$00004F01;
        dpmiregs.ecx:=dword(memw[listadr]);
        dpmiregs.es :=buf_16;
        dpmiregs.edi:=$00000000;
        callint($10,dpmiregs);
        move(pointer(buf_32)^,ModeInfo,sizeof(ModeInfo));
        if (word(dpmiregs.eax and $ffff)=$004F) and
        ((ModeInfo.attribute and 1+2+8+16+128)=1+2+8+16+128) and
        (ModeInfo.xres=xres) and (ModeInfo.yres=yres) and
        (ModeInfo.bpp=bpp) and (ModeInfo.flatadr>0)
        then modefound:=true else inc(listadr,2);
      end;
      searchmode:=memw[listadr];
    end;
  end;

  function  setmode(mode:word):boolean;
    var
      limit:dword;
      linearadr:dword;
      dpmiregs:tdpmiregs;
  begin
    if mode=$0013 then asm
      mov   ax,$0013
      int   10h
    end else begin
      asm
        mov    ax,$4F02
        mov    bx,mode
        add    bx,$4000
        int    10h
      end;
      linearadr:=ModeInfo.flatadr;
      if dpmiinstalled then begin
        limit:=VbeInfo.vidmem*64*1024;
        asm
          mov    eax,$0800
          mov    ebx,linearadr
          mov    ecx,ebx
          shr    ebx,16
          and    ecx,$0000ffff
          mov    esi,limit
          mov    edi,esi
          shr    esi,16
          and    edi,$0000ffff
          int    $31
          jnc    @skip
          xor    ebx,ebx
          xor    ecx,ecx
@skip:
          shl    ebx,16
          or     ebx,ecx
          mov    linearadr,ebx
        end;
      end else if vcpiinstalled then begin
        fillchar(dpmiregs,sizeof(dpmiregs),0);
        dpmiregs.eax:=$00001605;
        dpmiregs.edi:=$0000030A;
        dpmiregs.edx:=$00000001;
        callint($2F,dpmiregs);
        asm
          mov    ax,3
          int    10h
        end;
        write(  '  Windows Init Broadcast    : ');
				wininit:=(dpmiregs.ecx and $ffff)=0;
				writeln(bool[ord(wininit)]);
                                writeln('  Sorry, but current version of TMT does not run under VCPI!');
      end;
      if linearadr<>0 then begin
        pscreen:=linearadr;
        pBase:=linearadr;
        if ModeInfo.numpages>0 then PageSize:=ModeInfo.yres*ModeInfo.linesize
        else PageSize:=0;
      end else begin
        deinitvesa;
        writeln;
        writeln('DPMI-Memory mapping impossible... stopping RIGHT here!');
        halt;
      end;
    end;
  end;

  procedure deinitvesa;
    var
      dpmiregs:tdpmiregs;
  begin
    asm
      xor    eax,eax
      mov    al,lastmode
      int    10h
    end;
    if (vcpiinstalled) then begin
      fillchar(dpmiregs,sizeof(dpmiregs),0);
      dpmiregs.eax:=$00001606;
      dpmiregs.edx:=$00000001;
      callint($2F,dpmiregs);
    end;
  end;

begin

{$ifdef _debug_}
  initstr:='--<< DEBUG >>--';
{$endif}

  writeln(crlf,initstr,' module.',modname,' ',initstr);
  writeln('  module version            : ',modversion);

  write(  '  checking for host.DPMI    : ');
  dpmiinstalled:=checkdpmi;
  writeln(bool[ord(dpmiinstalled)]);

  write(  '  checking for host.VCPI    : ');
  vcpiinstalled:=checkvcpi;
  writeln(bool[ord(vcpiinstalled)]);

	vesainstalled:=initvesa;
  writeln('  VESA VBE Information      : ',
          bool[ord(vesainstalled)]);
  if vesainstalled then
  writeln('  VESA VBE Version          : ',
          VbeInfo.id,' ',hi(VbeInfo.version),'.',lo(VbeInfo.version));
end.
