Unit Mode13h;
{$R-}

Interface

Type
  RGBType = Record
    r, g, b : Byte;
  End;
  Palette = Array[0..255] of RGBType;

Var
  VGAPage, VirtualPage : Pointer;

Procedure SetMode(M : Longint);
Procedure PutMouseCursor(x, y : Longint);
Procedure SetRGB(c, r, g, b : Byte);
Procedure SetPalette(Var P);
Procedure Flip;

Implementation

Const
  MouseCursor : Array[0..7*7 - 1] of Byte = (
  0,0,0,1,0,0,0,
  0,0,0,1,0,0,0,
  0,0,1,1,1,0,0,
  1,1,1,0,1,1,1,
  0,0,1,1,1,0,0,
  0,0,0,1,0,0,0,
  0,0,0,1,0,0,0);

{
Procedure Flip;

Begin
  Move(VirtualPage^, Mem[$a0000], 64000);
  FillChar(VirtualPage^, 64000, 0);
End;
}

Procedure Flip; Assembler;

Asm
  Mov  edi,0a0000h
  Add  edi,_zero
  Mov  esi,VirtualPage
  Mov  ecx,64000/4
  Rep  Movsd

  Mov  edi,VirtualPage
  Xor  eax,eax
  Mov  ecx,64000/4
  Rep  Stosd
End;

Procedure SetMode(M : Longint); Assembler;

Asm
  Mov  eax,M
  Int  10h
End;

Procedure SetRGB(c, r, g, b : Byte);

Begin
  Port[$3c8] := c;
  Port[$3c9] := r;
  Port[$3c9] := g;
  Port[$3c9] := b;
End;

Procedure SetPalette(Var P);

Var
  i : DWord;
  pOfs : DWord;

Begin
  POfs := Ofs(P);
  For i := 0 to 255 do
    SetRGB(i, Mem[POfs+i*3], Mem[POfs+i*3+1], Mem[POfs+i*3+2]);
End;

Procedure PutPixel(x, y, c : Longint);

Var
  Addr : Longint;

Begin
  if (x < 0) or (x >= 320) Then Exit;
  if (y < 0) or (y >= 200) Then Exit;
  if (c = 0) Then Exit;

  Addr := Longint(VirtualPage);

  Mem[Addr + y * 320 + x] := c;
End;

Procedure PutMouseCursor(x, y : Longint);

Var
  i, j : Longint;

Begin
  For i := 0 to 6 do
    For j := 0 to 6 do
      PutPixel(x + j, y + i, MouseCursor[i*7+j]);
End;

Begin
{$IFNDEF __TMT__}
  VGAPage := Ptr(SegA000, 0);
{$ENDIF}
  Getmem(VirtualPage, 64000);
  FillChar(VirtualPage^, 64000, 0);
End.
